      subroutine emskewda(y,n,p,ng,ncov,dist,
     &pro,mu,sigma,dof,delta,tau,ev,elnv,ez1v,ez2v,
     &loglik,lk,clust,itmax,epsilon,error)
      implicit none
      integer n,p,ng,ncov,dist
      integer clust(*),itmax,error
      double precision y(n,*),mu(p,*),sigma(p,p,*),dof(*)
      double precision delta(p,*),pro(*),loglik,lk(*)
      double precision tau(n,*),ev(n,*),elnv(n,*)
      double precision ez1v(n,*),ez2v(n,*),epsilon
       error = 0
      if    (dist .eq. 1) then
        call emmvnda(y,n,p,ng,ncov,pro,
     &  mu,sigma,tau,clust,error)
      elseif(dist .eq. 2) then
        call emmvtda(y,n,p,ng,ncov,pro,
     &  mu,sigma,dof,tau,ev,
     &  loglik,lk,clust,itmax,epsilon,error)
      elseif(dist .eq. 3) then
        call emmsnda(y,n,p,ng,ncov,pro,
     &  mu,sigma,delta,tau,ev,ez2v,
     &  loglik,lk,clust,itmax,epsilon,error)
      elseif(dist .eq. 4) then
        call emmstda(y,n,p,ng,ncov,pro,
     &  mu,sigma,dof,delta,
     &  tau,ev,elnv,ez1v,ez2v,
     &  loglik,lk,clust,itmax,epsilon,error)
      endif
      return
      end
      subroutine emskewpred(x,n,p,g,dist,pro,mu,Sigma,dof,delta,
     &tau,clust,error)
      implicit NONE
      integer            n, p, G, error,dist, clust(*)
      double precision   x(n,*), tau(n,  *  ),dof(*),delta(p,*)
      double precision   mu(p,*), Sigma(p,p,*), pro(  *  )
      integer            j, h
      if(dist .lt. 3) then
         do j=1,p
           do h =1,g
            delta(j,h)=dble(0)
           enddo
         enddo
      endif
      error = 0
      if    (dist .eq. 1) then
         call predmixdamsn(x,n,p,g,pro,mu,Sigma,    delta,tau,error)
      elseif(dist .eq. 2) then
         call predmixdamst(x,n,p,g,pro,mu,Sigma,dof,delta,tau,error)
      elseif(dist .eq. 3) then
         call predmixdamsn(x,n,p,g,pro,mu,Sigma,    delta,tau,error)
      elseif(dist .eq. 4) then
         call predmixdamst(x,n,p,g,pro,mu,Sigma,dof,delta,tau,error)
      endif
      call tau2clust(tau, n, g, clust)
      return
      end
